<?php

/**
 * novedad_cesion actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage novedad_cesion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class novedad_cesionActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVC_NOVEDAD_CESION_V',
        'RVC_CONTRATO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RVC_CONTRATO_V,LEFT' =>
        array(
            'id_contrato' => 'RVC_NOVEDAD_CESION_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVC_NOVEDAD_CESION_V' =>
        array(
            'id_novedad_cesion' => 'id_novedad_cesion',
            'id_contrato' => 'id_contrato',
            'fecha' => 'fecha',
            'numero_doc' => 'numero_doc',
            'fecha_doc' => 'fecha_doc',
            'observaciones' => 'observaciones',
            'fecha_cesion' => 'fecha_cesion',
            'adjunto' => 'adjunto',
            'id_contratista_old' => 'id_contratista_old',
            'rp_anm_old' => 'rp_anm_old',
            'rp_sgr_old' => 'rp_sgr_old',
            'fecha_rp_old' => 'fecha_rp_old',
            'id_contratista_new' => 'id_contratista_new',
            'rp_anm_new' => 'rp_anm_new',
            'rp_sgr_new' => 'rp_sgr_new',
            'fecha_rp_new' => 'fecha_rp_new',
            'usuario_log' => 'usuario_log',
            'fecha_log' => 'fecha_log',
            'num_contrato' => 'num_contrato',
            'id_anhos' => 'id_anhos',
            'fecha_contrato' => 'fecha_contrato',
            'estado_cont' => 'estado_cont',
            'num_doc_contraold' => 'num_doc_contraold',
            'razon_social_contraold' => 'razon_social_contraold',
            'correo_contraold' => 'correo_contraold',
            'num_doc_contranew' => 'num_doc_contranew',
            'razon_social_contranew' => 'razon_social_contranew',
            'correo_contranew' => 'correo_contranew',
            'num_doc_usu_log' => 'num_doc_usu_log',
            'razon_soc_usu_log' => 'razon_soc_usu_log',
            'id_contrato_new' => 'id_contrato_new',
            'fecha_rp_sgr_old' => 'fecha_rp_sgr_old',
            'fecha_rp_sgr_new' => 'fecha_rp_sgr_new',
            'fecha_inicio_cesion' => 'fecha_inicio_cesion'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVC_NOVEDAD_CESION_V' => array(
            'id_novedad_cesion,a' => array('!=' => array(-1)),
            'id_novedad_cesion,b' => array('=' => array('id_novedad_cesion')),
            'id_contrato' => array('=' => array('id_contrato')),
            'id_contratista_old' => array('=' => array('id_contratista_old')),
            'id_contratista_new' => array('=' => array('id_contratista_new')),
            'fecha_cesion' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'RVC_CONTRATO_V' => array(
            'id_contratista' => array('=' => array('id_contratista')),
            'id_supervisor' => array('=' => array('id_supervisor')),
            'id_apoyo_supervisor' => array('=' => array('id_apoyo_supervisor')),
            'num_contrato' => array('=' => array('num_contrato')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'id_anhos', 'num_contrato', 'fecha'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_novedad_cesion'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_novedad_cesion'); //llave primaria
    protected $field_names = array('id_contrato', 'fecha', 'numero_doc', 'fecha_doc', 'observaciones',
        'fecha_cesion', 'adjunto', 'id_contratista_old', 'rp_anm_old', 'rp_sgr_old', 'fecha_rp_old',
        'id_contratista_new', 'rp_anm_new', 'rp_sgr_new', 'fecha_rp_new', 'usuario_log', 'fecha_log',
        'fecha_rp_sgr_old', 'fecha_rp_sgr_new', 'fecha_inicio_cesion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVC_NOVEDAD_CESION'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_novedad_cesion'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
        // Valida que el acta de inicio del contrato este autorizada 
        $id_contrato = $request['id_contrato'];
        $sql = <<<EOD
select * 
from RVC_ACTA_INICIO_V 
where num_contrato = (select num_contrato from rvc_contrato where id_contrato = $id_contrato) 
    and estado_general_acta_ini = 4
EOD;
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) == 0) {
            $errors['mensaje'] = "Para poder registrar la novedad de cesión de un contrato, el mismo debe tener acta de inicio en estado autorizado.";
            $errors['servicio'] = "novedad_cesión";
        }

        //Validacion en RVC novedad cesion no dejar para el mismo id_contrato - 20240429::LAVILA
        $sql = <<<EOD
select * 
from rvc_novedad_cesion 
where id_contrato = $id_contrato 
EOD;
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {
            $errors['mensaje'] = "Ya se encuentra registrada la novedad de cesión para este contrato, recomendamos verificar novedad registrada.";
            $errors['servicio'] = "novedad_cesión";
        }

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $request['usuario_log'] = $request['username'];
            //$request['fecha_log'] = CN_TABLE::fechaSistema();
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_contrato = $list_data_post[0]['id_contrato'];
                $id_contratista_new = $list_data_post[0]['id_contratista_new'];
                $rp_anm_new = !empty($list_data_post[0]['rp_anm_new']) ? $list_data_post[0]['rp_anm_new'] : 'null';
                $rp_sgr_new = !empty($list_data_post[0]['rp_sgr_new']) ? $list_data_post[0]['rp_sgr_new'] : 'null';
                $fecha_rp_new = $list_data_post[0]['fecha_rp_new'];
                $fecha_rp_sgr_new = $list_data_post[0]['fecha_rp_sgr_new'];
                $id_novedad_cesion = $list_data_post[0]['id_novedad_cesion'];
                $fecha_cesion = $list_data_post[0]['fecha_cesion'];
                $fecha_inicio_cesion = $list_data_post[0]['fecha_inicio_cesion'];

                /*
                 * Crea contrato nuevo - 20181106              
                 * Campos nuevos de contrato - 20211001::LAVILA
                 * Se cambia por fecha independiente SGR - 20220316::LAVILA
                 * nvl(fecha_rp_sgr,nvl(to_date('$fecha_rp_new','yyyy-mm-dd'),fecha_rp)) as fecha_rp_sgr,
                 */
                $sql = <<<EOD
insert into rvc_contrato
(id_contrato,
id_contratista,
num_contrato,
id_anhos,
fecha_contrato,
objeto,
obligaciones,
estado,
rp_anm,
rp_sgr,
fecha_rp,
fecha_rp_sgr,
fecha_poliza,
valor_anm,
cdp_anm,
fecha_cdp_anm,
valor_sgr,
cdp_sgr,
fecha_cdp_sgr,
dependencia,
meses_plazo,
dias_plazo,
fecha_plazo,
id_supervisor,
id_apoyo_supervisor,
fecha_ini,
fecha_fin,
marca_act_estado,
numero_pago,
valor_mensualizado,
adjunto_contrato,
adjunto_poliza,
id_area,
id_tipo_contrato,
tipo_recurso,
id_co_contrato)
                        
select
null as id_contrato,
'$id_contratista_new' as id_contratista,
num_contrato,
id_anhos,
fecha_contrato,
objeto,
obligaciones,
estado,
nvl($rp_anm_new,rp_anm) as rp_anm,
nvl($rp_sgr_new,rp_sgr) as rp_sgr,
nvl(to_date('$fecha_rp_new','yyyy-mm-dd'),fecha_rp) as fecha_rp,
nvl(to_date('$fecha_rp_sgr_new','yyyy-mm-dd'),fecha_rp_sgr) as fecha_rp_sgr,
fecha_poliza,
valor_anm,
cdp_anm,
fecha_cdp_anm,
valor_sgr,
cdp_sgr,
fecha_cdp_sgr,
dependencia,
meses_plazo,
dias_plazo,
fecha_plazo,
id_supervisor,
id_apoyo_supervisor,
fecha_ini,
fecha_fin,
marca_act_estado,
numero_pago,
valor_mensualizado,
adjunto_contrato,
adjunto_poliza,
id_area,
id_tipo_contrato,
tipo_recurso,
id_co_contrato
from rvc_contrato
where
id_contrato = $id_contrato                      
EOD;
                $this->conn->execute($sql);

                /**
                 * Validar segun fecha de terminacion de cesion que contrato inactiva, activo y en estado aprobado - 20220316::LAVILA
                 */
                //sentencia sql
                $sql = <<<EOD
SELECT
* 
FROM rvc_formato_pago 
where
estado = 1
and aprobado = 1
and id_contrato = $id_contrato
and to_date('$fecha_cesion','yyyy-mm-dd') BETWEEN fecha_ini_pago and fecha_fin_pago 
EOD;
                //ejecuta el sql
                $resultado_terdu = CN_TABLE::executeSQL($sql);
                if (count($resultado_terdu) > 0) {
                    //inactiva contrato anterior
                    $sql = <<<EOD
update rvc_contrato 
set estado = 0
where id_contrato = $id_contrato                      
EOD;
                    $this->conn->execute($sql);
                } else {
                    //inactiva contrato nuevo
                    $sql = <<<EOD
update rvc_contrato 
set estado = 0
where id_contrato = ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont where cont.id_contrato = $id_contrato) ) )                      
EOD;
                    $this->conn->execute($sql);
                }

                //actualiza nov cesion - 20181106
                $sql = <<<EOD
UPDATE rvc_novedad_cesion 
SET id_contrato_new = ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont where cont.id_contrato = $id_contrato) ) )
WHERE id_novedad_cesion = $id_novedad_cesion                    
EOD;
                $this->conn->execute($sql);

                //Insertamos los RPs
                // 20220928 Se actualiza metodo para Insertar RPS del Nuevo Contrato
                // Se copian los RPs anteriores con valor 0
                // Si no existe se crea una nueva linea
                // Se inserta le nuevo Rp con los valores obtenidos desde la vista RPS_CONTRATO_V
                // Se actualiza le valor de contrato nuevo en pgn o sgr al valor obtenido desde la vista RPS_CONTRATO_V

                $sql = <<<EOD
                    INSERT INTO RVC_RPS_CDPS_CONTRATO
(
  ID_RPS_CDPS_CONTRATO,
  ID_CONTRATO,
  NUM_CONTRATO,
  ESTADO,
  RP,
  FECHA_RP,
  CDP,
  FECHA_CDP,
  TIPO_RECURSO,
  valor_rp,
  principal
)
    select 
        null,
        ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato) )) as id_contrato,
        tab0.num_contrato as num_contrato,
        tab0.estado,
        tab0.rp,
        tab0.fecha_rp,
        tab0.cdp,
        tab0.fecha_cdp,
        tab0.tipo_recurso,
        0 as valor_rp,
        0 as principal
    from RVC_RPS_CDPS_CONTRATO tab0
    where tab0.id_contrato = $id_contrato
EOD;


                $this->conn->execute($sql);
                // Insertamos nuevos RPS
                if ($rp_anm_new !== 'null') {
                    $sql = <<<EOD
                    INSERT INTO RVC_RPS_CDPS_CONTRATO
                        (
                          ID_RPS_CDPS_CONTRATO,
                          ID_CONTRATO,
                          NUM_CONTRATO,
                          ESTADO,
                          RP,
                          FECHA_RP,
                          CDP,
                          FECHA_CDP,
                          TIPO_RECURSO,
                          VALOR_RP,
                          PRINCIPAL
                        )
                        select 
                            null,
                            ( select max(id_contrato) from rvc_contrato 
where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
    where cont.id_contrato = $id_contrato) )) as id_contrato,
                            (select num_contrato from rvc_contrato where id_contrato = $id_contrato),
                            a.estado,
                            a.rp,
                            a.fecha,
                            a.cdp,
                            a.fecha_cdp,
                            0 as tipo_recurso,
                            a.valor,
                            1 as principal
                        from RPS_CONTRATO_V a 
                        where a.RP = $rp_anm_new and a.sgr = 0 and a.vigencia > 2020
EOD;
                    $this->conn->execute($sql);
                    // Confirmamos que el RP PGN esta asociado en contratos si no hacemos la asociacion
                    $sql = <<<EOD
select * 
from co_legaliza_contrato
where id_rp = $rp_anm_new 
    and rp_sgr = 0 
    and id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                    $result = CN_TABLE::executeSQL($sql);
                    if (count($result) == 0) { // Sin existe realizamos asociasion
                        // Agregamos registro en tabla CO_PROYECTo_EP
                        // Validamos que el proyecto no exista
                        $sql = <<<EOD
select * 
from co_proyecto_ep
where ID_CPO = (select id_cpo from pr_rp_compromiso
        where id_rp = $rp_anm_new and vigencia >= 2020 group by id_rp,id_cpo)
and id_estudios_previos = (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)))
and SGR = 0
EOD;
                        $result = CN_TABLE::executeSQL($sql);
                        if (count($result) == 0) {
                            $sql = <<<EOD
INSERT INTO CO_PROYECTO_EP(ID_CPO,ID_ESTUDIOS_PREVIOS,VALOR,SGR)
SELECT ID_CPO,
    (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))) as ID_ESTUDIOS_PREVIOS,
    VALOR,
    0 as SGR
    from (select id_rp,id_cpo, sum(valor) as valor from pr_rp_compromiso 
        where id_rp = $rp_anm_new group by id_rp,id_cpo)
EOD;
                            $this->conn->execute($sql);
                        }
                        // Agregamos Registro RP en CO_LEGALIZA_CONTRATO
                        $sql = <<<EOD
INSERT INTO CO_LEGALIZA_CONTRATO(ID_CONTRATO,ID_RP,FECHA_APRUEBA_POLIZA,FECHA_INICIO,FECHA_TERMINACION,RP_SGR,VIGENCIA_RP)
select 
    (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato) as ID_CONTRATO,
    $rp_anm_new,    
    leg.FECHA_APRUEBA_POLIZA,leg.FECHA_INICIO,leg.FECHA_TERMINACION,
    0 as SGR,
    rp.vigencia
FROM (select max(FECHA_APRUEBA_POLIZA) as FECHA_APRUEBA_POLIZA,
    max(FECHA_INICIO) as FECHA_INICIO,max(FECHA_TERMINACION) as FECHA_TERMINACION 
        from CO_LEGALIZA_CONTRATO where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))leg
    left join RPS_CONTRATO_V rp on rp.id = $rp_anm_new and rp.estado = 1 and rp.sgr = 0 and rp.vigencia >= 2020
                              
EOD;
                        $this->conn->execute($sql);
                    }
                }
                if ($rp_sgr_new != 'null') {
                    $sql = <<<EOD
                            INSERT INTO RVC_RPS_CDPS_CONTRATO
                                (
                                  ID_RPS_CDPS_CONTRATO,
                                  ID_CONTRATO,
                                  NUM_CONTRATO,
                                  ESTADO,
                                  RP,
                                  FECHA_RP,
                                  CDP,
                                  FECHA_CDP,
                                  TIPO_RECURSO,
                                  VALOR_RP,
                                  PRINCIPAL
                                )
                                select 
                                    null,
                                    ( select max(id_contrato) from rvc_contrato 
        where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
            where cont.id_contrato = $id_contrato) )) as id_contrato,
                                    (select num_contrato from rvc_contrato where id_contrato = $id_contrato),
                                    a.estado,
                                    a.rp,
                                    a.fecha,
                                    a.cdp,
                                    a.fecha_cdp,
                                    1 as tipo_recurso,
                                    a.valor,
                                    1 as principal
                                from RPS_CONTRATO_V a 
                                where a.RP = $rp_sgr_new and a.sgr = 1 and a.vigencia > 2020
EOD;
                    $this->conn->execute($sql);
                    // Confirmamos que el RP SGR esta asociado en contratos si no hacemos la asociacion
                    $sql = <<<EOD
select * 
from co_legaliza_contrato
where id_rp = $rp_sgr_new 
    and rp_sgr = 1 
    and id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                    $result = CN_TABLE::executeSQL($sql);
                    if (count($result) == 0) { // Sin existe realizamos asociasion
                        //// Validamos que el proyecto no exista
                        $sql = <<<EOD
select * 
from co_proyecto_ep
where ID_CPO = (select id_cpo from pr_rp_compromiso@PNG_SGR$tag_ent_sgr
        where id_rp = $rp_sgr_new and vigencia >= 2020 group by id_rp,id_cpo)
and id_estudios_previos = (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)))
and SGR = 1
EOD;
                        $result = CN_TABLE::executeSQL($sql);
                        if (count($result) == 0) {
                            // Agregamos registro en tabla CO_PROYECTo_EP
                            $sql = <<<EOD
INSERT INTO CO_PROYECTO_EP(ID_CPO,ID_ESTUDIOS_PREVIOS,VALOR,SGR)
SELECT ID_CPO,
    (select id_estudios_previos 
     from CO_SELECCION_EP 
     where id_seleccion_ep = (select ID_SELECCION_EP from co_contrato where id_contrato = 
         (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))) as ID_ESTUDIOS_PREVIOS,
    VALOR,
    1 as SGR
    from (select id_rp,id_cpo, sum(valor) as valor from pr_rp_compromiso@PNG_SGR$tag_ent_sgr
        where id_rp = $rp_sgr_new and vigencia >= 2020 group by id_rp,id_cpo)
EOD;
                            $this->conn->execute($sql);
                        }
                        // Agregamos Registro RP en CO_LEGALIZA_CONTRATO
                        $sql = <<<EOD
INSERT INTO CO_LEGALIZA_CONTRATO(ID_CONTRATO,ID_RP,FECHA_APRUEBA_POLIZA,FECHA_INICIO,FECHA_TERMINACION,RP_SGR,VIGENCIA_RP)
select 
    (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato) as ID_CONTRATO,
    $rp_sgr_new,    
    leg.FECHA_APRUEBA_POLIZA,leg.FECHA_INICIO,leg.FECHA_TERMINACION,
    0 as SGR,
    rp.vigencia
FROM (select max(FECHA_APRUEBA_POLIZA) as FECHA_APRUEBA_POLIZA,
    max(FECHA_INICIO) as FECHA_INICIO,max(FECHA_TERMINACION) as FECHA_TERMINACION 
        from CO_LEGALIZA_CONTRATO where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato))leg
    left join RPS_CONTRATO_V rp on rp.id = $rp_sgr_new and rp.estado = 1 and rp.sgr = 1 and rp.vigencia >= 2020
                              
EOD;
                        $this->conn->execute($sql);
                    }
                }

                // Actualizamos el VAlor del contrato nuevo
                $sql = <<<EOD
                UPDATE RVC_CONTRATO set (valor_anm,valor_sgr) =         
                    (select 
                        sum(case when tipo_recurso = 0 then valor_rp else 0 end) as valor_anm,
                        sum(case when tipo_recurso = 1 then valor_rp else 0 end) as valor_sgr
                    from
                        RVC_RPS_CDPS_CONTRATO 
                    where id_contrato = (select max(id_contrato) from rvc_contrato 
                    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
                    where cont.id_contrato = $id_contrato))))
                WHERE id_contrato = (select max(id_contrato) from rvc_contrato 
                where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
                    where cont.id_contrato = $id_contrato)))
EOD;
                $this->conn->execute($sql);

                // Actualizar numero de pagos en la tabla co_contrato
                $sql = <<<EOD
UPDATE CO_CONTRATO 
set  numero_pago = (
    select 
 case when cesion.pagos is null then prorroga.pagos else cesion.pagos end as pagos
from
    (select sum(tab0.pagos) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, max(tab0.fecha_ini) as fecha_ini,min(tab0.fecha_fin) as fecha_fin, 
        ceil(MONTHS_BETWEEN(last_day(min(tab0.fecha_fin)), to_date(to_char(max(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, tab0.fecha_ini,tab1.fecha_cesion as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato
        UNION
        select tab0.id_contrato, tab0.num_contrato, tab1.fecha_cesion as fecha_ini ,tab0.fecha_fin as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato_new)tab0
        where tab0.num_contrato = (select num_contrato from rvc_contrato where id_contrato =$id_contrato)
        group by tab0.id_contrato, tab0.num_contrato)tab0)cesion
left join (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato ))
)prorroga on 1=1) 
where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato)
EOD;
                $this->conn->execute($sql);

                // Actualizar numero de pagos en la tabla rvc_contrato
                $sql = <<<EOD
UPDATE RVC_CONTRATO 
set  numero_pago = (
    select 
 case when cesion.pagos is null then prorroga.pagos else cesion.pagos end as pagos
from
    (select sum(tab0.pagos) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, max(tab0.fecha_ini) as fecha_ini,min(tab0.fecha_fin) as fecha_fin, 
        ceil(MONTHS_BETWEEN(last_day(min(tab0.fecha_fin)), to_date(to_char(max(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
        from(
        select tab0.id_contrato, tab0.num_contrato, tab0.fecha_ini,tab1.fecha_cesion as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato
        UNION
        select tab0.id_contrato, tab0.num_contrato, tab1.fecha_cesion as fecha_ini ,tab0.fecha_fin as fecha_fin
        from rvc_contrato tab0
        join rvc_novedad_cesion tab1 on tab0.id_contrato = tab1.id_contrato_new)tab0
        where tab0.num_contrato = (select num_contrato from rvc_contrato where id_contrato =$id_contrato)
        group by tab0.id_contrato, tab0.num_contrato)tab0)cesion
left join (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato ))
)prorroga on 1=1) 
where id_contrato =  (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                $this->conn->execute($sql);

                // ACtualizar Meses y dias plazo para el contrato nuevo
                // Obtenemos fecha inicio y fecha fin contrato nuevo
                $sql = <<<EOD
Select to_char(fecha_ini,'YYYY-MM-DD') as fecha_inicio, to_char(fecha_fin,'YYYY-MM-DD') as fecha_fin
FRom RVC_CONTRATO
where id_contrato = (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                $result = CN_TABLE::executeSQL($sql);
                $fecha_ini = $result[0]['fecha_inicio'];
                $fecha_fin = $result[0]['fecha_fin'];
                $fecha_ini = new DateTime($fecha_ini);
                $fecha_fin = new DateTime($fecha_fin);
                $diferencia = $fecha_ini->diff($fecha_fin);
                //execute sql
                $record = array();
                $anhos = $diferencia->y;
                $meses = $diferencia->m + ($anhos * 12);
                $dias = $diferencia->d + 1;
                // Actualizamos el registro
                $sql = <<<EOD
UPDATE rvc_contrato set meses_plazo = $meses, dias_plazo = $dias
where id_contrato = (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato )))
EOD;
                $this->conn->execute($sql);

                //Incidente #35171, se crea registro copia de la tabla rvc_rps_saldo_no_ejecutado por bienio - 20230330::LAVILA
                $sql = <<<EOD
insert into rvc_rps_saldo_no_ejecutado (
ID,
ID_CONTRATO,
ESTADO,
RP,
VIGENCIA,
TIPO_RECURSO,
VALOR,
ID_CPO
)

select
null as ID,
( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato) ) ) as ID_CONTRATO,
ESTADO,
RP,
VIGENCIA,
TIPO_RECURSO,
VALOR,
ID_CPO
from rvc_rps_saldo_no_ejecutado

where
id_contrato = $id_contrato 
EOD;
                $this->conn->execute($sql);

                //Commit de transacciones
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
